package com.egommerce.apigateway.module;

import com.google.inject.AbstractModule;
import com.google.inject.Scopes;
import com.netflix.appinfo.ApplicationInfoManager;
import com.netflix.appinfo.EurekaInstanceConfig;
import com.netflix.appinfo.InstanceInfo;
import com.netflix.appinfo.MyDataCenterInstanceConfig;
import com.netflix.appinfo.providers.EurekaConfigBasedInstanceInfoProvider;
import com.netflix.discovery.DiscoveryClient;
import com.netflix.discovery.DefaultEurekaClientConfig;
import com.netflix.discovery.EurekaClient;
import com.netflix.discovery.EurekaClientConfig;
// import org.slf4j.Logger;
// import org.slf4j.LoggerFactory;

public class ApiGwEurekaModule extends AbstractModule {
    // private static final Logger log = LoggerFactory.getLogger(ApiGwFiltersModule.class);

    @Override
    protected void configure() {
        // need to eagerly initialize
        bind(ApplicationInfoManager.class).asEagerSingleton();
        bind(EurekaClient.class).to(DiscoveryClient.class).in(Scopes.SINGLETON);
        
        bind(EurekaInstanceConfig.class).to(MyDataCenterInstanceConfig.class);
        bind(EurekaClientConfig.class).to(DefaultEurekaClientConfig.class);
        // bind(EurekaClientConfig.class).toProvider(DefaultEurekaClientConfigProvider.class).in(Scopes.SINGLETON);
        
        // // this is the self instanceInfo used for registration purposes
        bind(InstanceInfo.class).toProvider(EurekaConfigBasedInstanceInfoProvider.class).in(Scopes.SINGLETON);
    }

    @Override
    public boolean equals(Object obj) {
        return obj != null && getClass().equals(obj.getClass());
    }

    @Override
    public int hashCode() {
        return getClass().hashCode();
    }
}
